.386
.model flat,stdcall
option casemap:none
include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include gdi32.inc
includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib gdi32.lib

WM_SHELLNOTIFY equ WM_USER+5
IDI_TRAY 	equ 0
IDM_SHOW 	equ 1000
IDM_EXIT	equ 1010
IDM_HIDE	equ 1020
BMP_PT		equ	300
BMP_R0		equ 400
BMP_R1		equ 500

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data
ClassName 		db "ZigomarWinClass",0
AppName  		db "Zigomar Utilities",0
ShowString		db "Show Clock",0
HideString		db "Hide Clock",0
ExitString	 	db "Close Zigomar",0
ImIVisible		db TRUE

.data?
hInstance		dd ?
hPopupMenu		dd ?
hRegion			dd ?
hRMask			dd ?
hBMP_PT			dd ?
hBMP_R0			dd ?
hBMP_R1			dd ?
S0				dw ?
S1				dw ?
M0				dw ?
M1				dw ?
H0				dw ?
H1				dw ?
hCellOFF		dd ?
hCellON			dd ?
hPT				dd ?

TimeNow			SYSTEMTIME <>	; Current time
note 			NOTIFYICONDATA <>

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
	invoke ExitProcess,eax
	
TimeGet proc
	invoke   GetLocalTime, ADDR TimeNow
	mov cx,10
	mov ax,TimeNow.wHour
	div cl
	mov bx,ax
	and ax,255
	mov H1,ax
	shr bx,8
	mov H0,bx
	mov ax,TimeNow.wMinute
	div cl
	mov bx,ax
	and ax,255
	mov M1,ax
	shr bx,8
	mov M0,bx
	mov ax,TimeNow.wSecond
	div cl
	mov bx,ax
	and ax,255
	mov S1,ax
	shr bx,8
	mov S0,bx
	Ret
TimeGet endp


MakeRegions proc hWnd:HWND
		invoke CreateRectRgn,10,10,145,85
		mov hRegion,eax
		invoke CreateRectRgn,0,0,30,50
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,45,10,80,30
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,95,10,130,30
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF				
		invoke CreateRectRgn,45,30,60,85
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF				
		invoke CreateRectRgn,95,30,110,85
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF				
		invoke CreateRectRgn,25,50,30,85
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,75,30,80,85
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,125,30,130,85
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,30,25,145,30
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,30,45,145,50
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,10,65,145,70
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_DIFF
		invoke CreateRectRgn,51,50,54,54
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,50,51,55,53
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,51,60,54,64
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,50,61,55,63
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,101,50,104,54
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,100,51,105,53
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,101,60,104,64
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke CreateRectRgn,100,61,105,63
		mov hRMask,eax
		invoke CombineRgn,hRegion,hRegion,hRMask,RGN_OR	
		invoke SetWindowRgn,hWnd,hRegion,0
		invoke DeleteObject,hRMask
		invoke DeleteObject,hRegion
	Ret
MakeRegions endp

GoToTray proc hWnd:HWND, Visibility:DWORD
	mov note.cbSize,sizeof NOTIFYICONDATA
	push hWnd
	pop note.hwnd
	mov note.uID,IDI_TRAY
	mov note.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
	mov note.uCallbackMessage,WM_SHELLNOTIFY
	invoke LoadIcon,hInstance,200
	mov note.hIcon,eax
	invoke lstrcpy,addr note.szTip,addr AppName
	invoke ShowWindow,hWnd,Visibility
	invoke Shell_NotifyIcon,NIM_ADD,addr note
	Ret
GoToTray endp

PainCell proc hMemDC:HDC,hDC:DWORD,X:WORD,Y:WORD,rect:RECT,hCell0:DWORD,hCell1:DWORD
	mov 	eax,hCell0
    test   	S0,1
    jz 	   	@LS0
	mov 	eax,hCell1
    @LS0:
    invoke 	SelectObject,hMemDC,eax
    invoke 	BitBlt,HDC ptr hDC,X,Y,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
	Ret
PainCell endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	;class init
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_APPWORKSPACE
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	;icon and cursor load
	invoke LoadIcon,hInst,200
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov	  wc.hCursor,eax
	;loading bitmaps
	invoke  LoadBitmap,hInst,BMP_PT
	mov hBMP_PT,eax
	invoke  LoadBitmap,hInst,BMP_R0
	mov hBMP_R0,eax
	invoke  LoadBitmap,hInst,BMP_R1
	mov hBMP_R1,eax
	; assigning handles
	mov eax,hBMP_R0
	mov hCellOFF,eax
	mov eax,hBMP_R1
	mov hCellON,eax
	mov eax,hBMP_PT
	mov hPT,eax
	;class registration and window creation
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,WS_EX_NOACTIVATE + WS_EX_TOPMOST,ADDR ClassName,ADDR AppName,
           WS_POPUP + WS_VISIBLE,CW_USEDEFAULT,CW_USEDEFAULT,155,95,NULL,NULL,hInst,NULL
     mov   hwnd,eax
	;popup menu creation
	invoke CreatePopupMenu
	mov hPopupMenu,eax
	invoke AppendMenu,hPopupMenu,MF_STRING,IDM_SHOW,addr ShowString
	invoke AppendMenu,hPopupMenu,MF_STRING,IDM_HIDE,addr HideString
	invoke AppendMenu,hPopupMenu,MF_SEPARATOR,NULL,NULL
	invoke AppendMenu,hPopupMenu,MF_STRING,IDM_EXIT,addr ExitString
	invoke EnableMenuItem,hPopupMenu,IDM_SHOW,MF_GRAYED
	;show window and initialize menu
	invoke GoToTray,hwnd,SW_NORMAL
	;message loop
	.while TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	;end
	mov eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL pt:POINT
	LOCAL rect:RECT
	LOCAL ps:PAINTSTRUCT 
	LOCAL hDC:HDC 
	LOCAL hMemDC:HDC
	
	.if uMsg==WM_CREATE
		invoke MakeRegions,hWnd
		invoke SetTimer, hWnd, 1, 1000, NULL
		invoke TimeGet
	  		  		
	.elseif uMsg==WM_TIMER
		invoke TimeGet
		invoke GetClientRect,hWnd,addr rect
		invoke InvalidateRect,hWnd,addr rect,FALSE
		invoke SendMessage,hWnd,WM_PAINT,NULL,NULL
	
	.elseif uMsg==WM_PAINT
	    invoke BeginPaint,hWnd,addr ps 
      	mov    hDC,eax 
     	invoke CreateCompatibleDC,hDC 
     	mov    hMemDC,eax

     	invoke SelectObject,hMemDC,hPT
      	invoke GetClientRect,hWnd,addr rect 
      	invoke BitBlt,hDC,50,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
      	invoke BitBlt,hDC,50,60,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
      	invoke BitBlt,hDC,100,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
      	invoke BitBlt,hDC,100,60,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY 
		
		mov 	eax,hCellOFF
    	test   	S0,1
    	jz 	   	@LS1
		mov 	eax,hCellON
    	@LS1:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,130,70,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
    		
		mov 	eax,hCellOFF
    	test   	S0,2
    	jz 	   	@LS2
		mov 	eax,hCellON
    	@LS2:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,130,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	S0,4
    	jz 	   	@LS3
		mov 	eax,hCellON
    	@LS3:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,130,30,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
    	    	    	      			
		mov 	eax,hCellOFF
    	test   	S0,8
    	jz 	   	@LS4
		mov 	eax,hCellON
    	@LS4:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,130,10,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	S1,1
    	jz 	   	@HS1
		mov 	eax,hCellON
    	@HS1:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,110,70,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	S1,2
    	jz 	   	@HS2
		mov 	eax,hCellON
    	@HS2:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,110,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	S1,4
    	jz 	   	@HS3
		mov 	eax,hCellON
    	@HS3:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,110,30,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	M0,1
    	jz 	   	@LM1
		mov 	eax,hCellON
    	@LM1:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,80,70,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	M0,2
    	jz 	   	@LM2
		mov 	eax,hCellON
    	@LM2:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,80,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	M0,4
    	jz 	   	@LM3
		mov 	eax,hCellON
    	@LM3:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,80,30,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
    	
		mov 	eax,hCellOFF
    	test   	M0,8
    	jz 	   	@LM4
		mov 	eax,hCellON
    	@LM4:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,80,10,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	M1,1
    	jz 	   	@HM1
		mov 	eax,hCellON
    	@HM1:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,60,70,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	M1,2
    	jz 	   	@HM2
		mov 	eax,hCellON
    	@HM2:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,60,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	M1,4
    	jz 	   	@HM3
		mov 	eax,hCellON
    	@HM3:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,60,30,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	H0,1
    	jz 	   	@LH1
		mov 	eax,hCellON
    	@LH1:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,30,70,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	H0,2
    	jz 	   	@LH2
		mov 	eax,hCellON
    	@LH2:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,30,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	H0,4
    	jz 	   	@LH3
		mov 	eax,hCellON
    	@LH3:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,30,30,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	H0,8
    	jz 	   	@LH4
		mov 	eax,hCellON
    	@LH4:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,30,10,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	H1,1
    	jz 	   	@HH1
		mov 	eax,hCellON
    	@HH1:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,10,70,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		mov 	eax,hCellOFF
    	test   	H1,2
    	jz 	   	@HH2
		mov 	eax,hCellON
    	@HH2:
   	 	invoke 	SelectObject,hMemDC,eax
    	invoke 	BitBlt,hDC,10,50,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY

		invoke EndPaint,hWnd,addr ps
		invoke DeleteDC,hMemDC
		invoke DeleteDC,hDC
		
	.elseif uMsg==WM_DESTROY
		invoke DestroyMenu,hPopupMenu
		invoke PostQuitMessage,NULL
		
	.elseif uMsg==WM_COMMAND
		.if lParam==0
			mov eax,wParam
			.if ax==IDM_SHOW
				invoke ShowWindow,hWnd,SW_RESTORE
				invoke EnableMenuItem,hPopupMenu,IDM_SHOW,MF_GRAYED
				invoke EnableMenuItem,hPopupMenu,IDM_HIDE,MF_ENABLED
				mov ImIVisible,TRUE
			.elseif ax==IDM_HIDE
				invoke ShowWindow,hWnd,SW_HIDE
				invoke EnableMenuItem,hPopupMenu,IDM_SHOW,MF_ENABLED
				invoke EnableMenuItem,hPopupMenu,IDM_HIDE,MF_GRAYED
				mov ImIVisible,FALSE
			.else
				invoke Shell_NotifyIcon,NIM_DELETE,addr note
				invoke DestroyWindow,hWnd
			.endif
		.endif
		
	.elseif uMsg==WM_SHELLNOTIFY
		.if wParam==IDI_TRAY
			.if lParam==WM_RBUTTONDOWN
				invoke GetCursorPos,addr pt
				invoke SetForegroundWindow,hWnd
				invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN or TPM_RIGHTBUTTON,pt.x,pt.y,NULL,hWnd,NULL
				invoke PostMessage,hWnd,WM_NULL,0,0
			.elseif lParam==WM_LBUTTONDBLCLK
				.if ImIVisible==FALSE
					invoke SendMessage,hWnd,WM_COMMAND,IDM_SHOW,0
				.else
					invoke SendMessage,hWnd,WM_COMMAND,IDM_HIDE,0
				.endif
			.endif
		.endif
		
;	.elseif uMsg==WM_NCHITTEST
;		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
;		.if eax==HTCLIENT
;			mov eax,HTCAPTION
;			ret
;		.endif
	.elseif uMsg==WM_LBUTTONDBLCLK
		invoke SendMessage,hWnd,WM_COMMAND,IDM_HIDE,0
		
	.elseif uMsg==WM_LBUTTONDOWN
		invoke  SendMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
		
	.elseif uMsg==WM_RBUTTONDOWN
		invoke GetCursorPos,addr pt
		invoke SetForegroundWindow,hWnd
		invoke TrackPopupMenu,hPopupMenu,TPM_RIGHTALIGN or TPM_RIGHTBUTTON,pt.x,pt.y,NULL,hWnd,NULL
		invoke PostMessage,hWnd,WM_NULL,0,0
		
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

end start
